#!/bin/bash

basedir=$( dirname $0 )

channels=("France 2" "France 3" "France 4" "France 5" "France Ô" "Arte" "RMC Découverte" "TMC" "Numéro 23" "La Chaîne parlementaire" "NRJ 12" "C8" "BFM TV" "Franceinfo" "Chérie 25" "L'Equipe" "CNEWS" "CSTAR")

# Extract unused channels
channel_select=$(printf "display-name!=\"%s\" and " "${channels[@]}")
channel_select=${channel_select% and }
#echo $channel_select
#echo

program_filter=$( xmlstarlet select --template --match "/tv/channel" --if "$channel_select" --value-of "concat(@id,' ')" $basedir/tv_source.xml )

channel_filter=$(printf "@id='%s' or " ${program_filter[@]})
channel_filter=${channel_filter% or }
channel_filter="/tv/channel[$channel_filter]"
#echo $channel_filter
#echo

program_filter=$(printf "@channel='%s' or " ${program_filter[@]})
program_filter=${program_filter% or }
program_filter="/tv/programme[${program_filter%}]"
#echo $program_filter
#echo

#xmlstarlet edit --delete "$channel_filter" $basedir/tv_source.xml > $basedir/tv_new_1.xml
#xmlstarlet edit --delete "$program_filter" $basedir/tv_new_1.xml > $basedir/tv_new_2.xml
xmlstarlet edit --delete "$channel_filter" $basedir/tv_source.xml | xmlstarlet edit --delete "$program_filter" > $basedir/tv.xml
