<?php
header("Content-Type: text/html; charset=utf-8");

$base_dir = dirname(__FILE__);
$videos_dir = "$base_dir/_Enregistrements";
$videos_url = '_Enregistrements';

if (!empty($_SERVER['SERVER_NAME']))
   $base_url = ($_SERVER['HTTPS'] == 'on' ? 'https://' : 'http://') . $_SERVER['SERVER_NAME'];

$db = new mysqli('localhost', 'pvr', 'duconlajoie', 'pvr');

//========================================================================================
// Launch records
if (isset($argv) && $argv[1] == 'launch_records') {
   $base_url = $argv[2];
   
   if ($to_launch = $db->query('select id,channel,start,TIMEDIFF(stop,start) as delay, TIMESTAMPDIFF(SECOND,start,stop) + 600 as length,title,IF(launched=0,\'\',\'X\') as onair from records where launched = false and DATE_SUB(start, INTERVAL 5 MINUTE) <= now()')) {
      $channels_urls = file_get_contents("$base_dir/playlist.m3u");
      $url = array();

      print "Records to launch :\n";
      
      while ($info = $to_launch->fetch_array()) {
         $file_name = escapeshellcmd(str_replace(array(':', '\'', '?', '(', ')', '*', '&'), array('-',' ', ' ', ' ', ' ', ' ', ' '), "Le $info[start] pendant $info[delay] sur $info[channel] - $info[title]"));
         if (preg_match("|^#EXTINF:[0-9]+,[0-9]+ - .*$info[channel].*rtsp://mafreebox.freebox.fr/(fbxtv_pub/stream\?namespace=[0-9]+&service=[0-9]+&flavour=.+)$|misU", $channels_urls, $url)) {
            $cmd = "nohup curl --silent --max-time $info[length] --output '$videos_dir/$file_name.mpg' '$base_url/$url[1]' > /dev/null &";
            print "Start record at $info[start] during $info[delay] on $info[channel] : $info[title]'\n$cmd\n";
            system($cmd);
            print "\n";
            
            if ($stmt = $db->prepare('update records set launched=true where id = ?'))
               if ($stmt->bind_param('i', $info['id']))
                  if ($stmt->execute())
                     print "   Record '$info[id]' updated\n";
                  else
                     print "Mysql error : (" . $stmt->errno . ")" . $stmt->error;
                     else
                  print "Mysql error : (" . $stmt->errno . ") " . $stmt->error;
                  else
               print "Mysql error : (" . $db->errno . ") " . $db->error;
         } else {
            print "No match at $info[start] during $info[length] on $info[channel] : $info[title]'\n";
         }
      }
   } else
      print "Mysql error : (" . $db->errno . ") " . $db->error;     
//========================================================================================
// Add a record in the database
} else if (isset($_REQUEST['cmd']) && $_REQUEST['cmd'] == 'add') {
   $db->set_charset('latin1');
   
   if ($stmt = $db->prepare("insert into records (channel, start, stop, title, launched) values (?, STR_TO_DATE(?,'%Y%m%d%H%i%s'), STR_TO_DATE(?,'%Y%m%d%H%i%s'), ?, 0)"))
      if ($stmt->bind_param('ssss', $_REQUEST['channel'], $_REQUEST['start'], $_REQUEST['stop'], $_REQUEST['title']))
         if ($stmt->execute())
            print "Record inserted\n";
         else 
           print "Mysql error : (" . $stmt->errno . ") " . $stmt->error;
      else 
         print "Mysql error : (" . $stmt->errno . ") " . $stmt->error;
   else 
      print "Mysql error : (" . $db->errno . ") " . $db->error;
      
   $db->set_charset('utf8');
//========================================================================================
// Remove a record from the database
} else if (isset($_REQUEST['cmd']) && $_REQUEST['cmd'] == 'del') {
   if (is_numeric($_REQUEST['id']) && ($record = $db->query("select id,channel,start,timediff(stop,start) as delay,title,if(launched=0,'','X') as onair from records where id = $_REQUEST[id]"))) {
      $info = $record->fetch_array();
      $file_name = str_replace(array(':', '\'', '?', '(', ')', '*', '&'), array('-', ' ', ' ', ' ', ' ', ' ', ' '), "Le $info[start] pendant $info[delay] sur $info[channel] - $info[title]");
   } else
      $file_name = '';
   
   if ($stmt = $db->prepare('delete from records where id = ?'))
      if ($stmt->bind_param('i', $_REQUEST['id']))
         if ($stmt->execute()) {
            if (!empty($file_name))
               unlink("$videos_dir/$file_name.mpg"); 
            
            header("Location: pvr.php");
            print "<!-- \n";
            print "Record '$_REQUEST[id]' removed\n";
            print "File '$videos_dir/$file_name.mpg' removed\n";
            print " -->\n";
         } else
            print "Mysql error : (" . $stmt->errno . ") " . $stmt->error;
      else
         print "Mysql error : (" . $stmt->errno . ") " . $stmt->error;
   else
      print "Mysql error : (" . $db->errno . ") " . $db->error;
//========================================================================================
// Video streaming
} else if (isset($_REQUEST['asx'])) {
   $film = "$base_url/$videos_url/" . rawurlencode($_REQUEST['asx']);
   header("Content-type: video/x-ms-asf");
   echo <<< EOF
<asx version="3.0">
   <title>$film</title>
   <entry>
     <title>$film</title>
     <ref href="$film"/>
   </entry>
 </asx>
EOF;

} else if (isset($_REQUEST['m3u'])) {
   $film = "$base_url/$videos_url/" . rawurlencode($_REQUEST['m3u']);
   header("Content-type: application/vnd.apple.mpegurl");
   echo <<< EOF
#EXTM3U
#EXTVLCOPT:freetype-rel-fontsize=16
$film
EOF;
//========================================================================================
// List all records in the database
} else {
   $records = $db->query('set lc_time_names=\'fr_FR\'');
   $records = $db->query('select id,channel,start,date_format(start, \'%W %e %M %Y %H:%i:%s\') as debut, timediff(stop,start) as delay,title,if(launched=0,\'\',\'X\') as onair from records order by start,channel');

   if (!isset($argv)) {
      print "<html>\n<body>\n";
      print "<p><a href='index.php'>Menu</a> <a href='pvr.php'>Rafraichir</a></p>\n";
      print "<table border=1>\n";
      print "<tr><th>D&eacute;but<th>Dur&eacute;e<th>Cha&icirc;ne<th>Titre<th>Enregistr&eacute;<br>(ou en cours)\n";

      while ($info = $records->fetch_array()) {
         $file_name = htmlspecialchars(str_replace(array(':', '\'', '?', '(', ')', '*', '&'), array('-',' ', ' ', ' ', ' ', ' ', ' '), "Le $info[start] pendant $info[delay] sur $info[channel] - $info[title].mpg"));
         print "<tr><td>$info[debut]<td>$info[delay]<td>$info[channel]<td><a href='$videos_url/$file_name'><img src='images/download.gif' border=0 title='T&eacute;l&eacute;charger'></a> <a href='pvr.php?m3u=$file_name'><img src='images/vlc.gif' border=0 title='Voir'></a><a href='pvr.php?m3u=$file_name'>$info[title]</a><td align=center>" . (!empty($info['onair']) ? "<img src='images/ok.png' border=0>" : "") . "<td>" . ( empty($info['onair']) ? "<a href='pvr.php?cmd=del&id=$info[id]'>" : "<a href='pvr.php?cmd=del&id=$info[id]' onclick=\"if (confirm('L\'enregistrement va être supprimé.')) return true; else return false;\">" ) . "<img src='images/delete.png' border=0 title='Supprimer programmation et enregistrement'></a>\n";
         }

      print "</table>\n";
   
      print "<pre>Enregistrements en cours :\n\n";
      system("pgrep --full --list-full curl"); 
      print "</pre>\n";
      print "</body></html>\n";
      } else {
      while ($info = $records->fetch_array()) {
         print "$info[channel]\t$info[start]\t$info[delay]\t$info[title]\t$info[onair]\n";
      }

      system("ps xwau | grep curl");
   }
}

?>